//#include "pitches.h"
//#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Adafruit_NeoPixel.h>
#define OLED_RESET 4
Adafruit_SSD1306 display(128,64);
#include "Shapes.h"
#include <ESP32Servo.h>
#include <HCSR04.h>
#include "DHT.h"

#define DHTTYPE DHT11

#ifdef __AVR__
#include <avr/power.h> // From NeoPixel library
#endif


void readSerial();
union{
    byte byteVal[4];
    float floatVal;
    long longVal;
}val;

union{
  byte byteVal[8];
  double doubleVal;
}valDouble;

union{
  byte byteVal[2];
  short shortVal;
}valShort;

String mVersion = "0b.01.104";
boolean isAvailable = false;
boolean isBluetooth = false;

int len = 52;
char buffer[32];
char bufferBt[32];
byte indexx = 0;
byte dataLen;
byte modulesLen=0;
boolean isStart = false;
unsigned char irRead;
char serialRead;

/////////////////////

#define OLED_MOSI   9
#define OLED_CLK   10
#define OLED_DC    11
#define OLED_CS    12
#define OLED_RESET 13

/* Uncomment this block to use hardware SPI
#define OLED_DC     6
#define OLED_CS     7
#define OLED_RESET  8
Adafruit_SSD1306 display(128, 64, &SPI, OLED_DC, OLED_RESET, OLED_CS);
*/
 
// This section of the program is the four images for the cameo.
// Cameo17 and Cameo19 are the hearts.
 
#define CAMEO16_GLCD_HEIGHT 64
#define CAMEO16_GLCD_WIDTH 128
#define CAMEO17_GLCD_HEIGHT 64
#define CAMEO17_GLCD_WIDTH 128
#define CAMEO18_GLCD_HEIGHT 64
#define CAMEO18_GLCD_WIDTH 128
#define CAMEO19_GLCD_HEIGHT 64
#define CAMEO19_GLCD_WIDTH 128


/////////////////////
#define VERSION 0
#define ULTRASONIC_TEST 36
#define TEMPERATURE_SENSOR 2
#define LIGHT_SENSOR 3
#define POTENTIONMETER 4
#define JOYSTICK 5
#define GYRO 6
#define SOUND_SENSOR 7
#define RGBLED 8
#define SEVSEG 9
#define MOTOR 10
//#define SERVO 11
#define ENCODER 12
#define IR 13
#define IRREMOTE 14
#define PIRMOTION 15
#define INFRARED 16
#define LINEFOLLOWER 17
#define IRREMOTECODE 18
#define SHUTTER 20
#define LIMITSWITCH 21

#define HUMITURE 23
#define FLAMESENSOR 24
#define GASSENSOR 25
#define COMPASS 26
#define DIGITAL 30
#define ANALOG 31
#define PWM 32
#define TONE 34
#define PULSEIN 37
//#define ULTRASONIC_ARDUINO 36
#define STEPPER 40
#define LEDMATRIX 41
#define TIMER 50
#define TOUCH_SENSOR 51
#define LDR 36
#define POT 39
#define LEFT_BUTTON 35
#define RIGHT_BUTTON 34


//#define POT_TEST 19
#define SET_LED 28
#define RUN_MOTOR 29
#define DISPLAY_TEST 35
#define CLEAR_DISPLAY 39
#define DRAW_SHAPE 38
#define DRAW_SMILE 27
#define PWM_TEST 52
#define HUMITURE_TEST 53
#define RGB_TEST 54
#define INBUILT_SENSORS 55
#define SERVO 33


#define WELCOME_MENU 0
#define FEATURES_MENU 1
#define OUTPUTS_MENU 2
#define INPUTS_MENU 3



#define GET 1
#define RUN 2
#define RESET 4
#define START 5

//PIN CONFIGURATION
#define YELLOW 17
#define BLUE 33
#define GREEN 32
#define RED 16
#define LDR_PIN 36
#define POT_PIN 39
#define BUZZER_PIN 25
#define MOTOR_A1 16
#define MOTOR_A2 17
#define MOTOR_B1 32
#define MOTOR_B2 33
#define BUTTON_L 35
#define BUTTON_R 34
#define SERVO_PIN 33 //
#define HUMITURE_PIN 33 //
#define RGB_PIN 18//
#define TRIGGER_PIN  12  // Arduino pin tied to trigger pin on ping sensor.
#define ECHO_PIN     11  // Arduino pin tied to echo pin on ping sensor.
#define SERVO_PIN 21     // Recommended PWM GPIO pins on the ESP32 include 2,4,12-19,21-23,25-27,32-33 

// setting PWM properties
const int freq = 5000;
//int ledChannel =0;
const int resolution = 10; //Resolution 8, 10, 12, 15

 //Adafruit_NeoPixel pixels(0, 0, NEO_GRB + NEO_KHZ800); 

float angleServo = 90.0;
int servo_pins[8]={0,0,0,0,0,0,0,0};
unsigned char prevc=0;
double lastTime = 0.0;
double currentTime = 0.0;
uint8_t keyPressed = 0;
uint8_t command_index = 0;
 unsigned char readBuffer(int indexx){
 return isBluetooth?bufferBt[indexx]:buffer[indexx]; 
}

void writeBuffer(int indexx,unsigned char c){
 if(isBluetooth){
  bufferBt[indexx]=c;
 }else{
  buffer[indexx]=c;
 } 
}
void writeHead(){
  writeSerial(0xff);
  writeSerial(0x55);
}
void writeEnd(){
  Serial.println(); 
 #if defined(__AVR_ATmega32U4__) 
 // Serial1.println();
 #endif
}
void writeSerial(unsigned char c){
 Serial.write(c);
 #if defined(__AVR_ATmega32U4__) 
  //  Serial1.write(c);
 #endif
}
void readSerial(){
  isAvailable = false;
  if(Serial.available()>0){
    isAvailable = true;
    isBluetooth = false;
    serialRead = Serial.read();
  }
#if defined(__AVR_ATmega32U4__) 
  if( //Serial1.available()>0){
    isAvailable = true;
    isBluetooth = true;
    serialRead =  // Serial1.read();
  }
#endif
}

void charToStringL( char S[], String &D)
{
    byte at = 0;
    const char *p = S;
    D = "";

    while (*p++) {
      D.concat(S[at++]);
      }
}
/*
ff 55 len idx action device port  slot  data a
0  1  2   3   4      5      6     7     8
*/
void readSensor(int device){
  /**************************************************
      ff 55 len idx action device port slot data a
      0  1  2   3   4      5      6    7    8
  ***************************************************/
  float value=0.0;
  int port,slot,pin;
  port = readBuffer(6);
  pin = port;
  switch(device){
   case  ULTRASONIC_TEST:{
     float trig_pin = buffer[6];
     float eco_pin = buffer[7];
     HCSR04 hc(trig_pin,eco_pin);
     int distance = hc.dist();
    sendFloat(distance);
   }
   break;
   case  TEMPERATURE_SENSOR:{
     slot = readBuffer(7);
    // if(ts.getPort()!=port||ts.getSlot()!=slot){
     //  ts.reset(port,slot);
     //}
    // value = ts.temperature();
     sendFloat(value);
   }
   break;
   case  LIGHT_SENSOR:
   case  SOUND_SENSOR:
   case  POTENTIONMETER:{
    // if(generalDevice.getPort()!=port){
     //  generalDevice.reset(port);
      // pinMode(generalDevice.pin2(),INPUT);
    // }
   //  value = generalDevice.aRead2();
     sendFloat(value);
   }
   break;
   case  JOYSTICK:{
     slot = readBuffer(7);
   //  if(joystick.getPort() != port){
      // joystick.reset(port);
    // }
   //  value = joystick.read(slot);
     sendFloat(value);
   }
   break;
   case  INFRARED:
   {
//    // if(ir == NULL)
//     //{
//      // ir = new MeInfraredReceiver(port);
//      // ir->begin();
//   //  }
//     //else if(ir->getPort() != port)
//    // {
//     //  delete ir;
//      // ir = new MeInfraredReceiver(port);
//       //ir->begin();
//     //}
//     //irRead = ir->getCode();
//    // if((irRead < 255) && (irRead > 0))
//     {
//       sendFloat((float)irRead);
//     }
//     else
//     {
//       sendFloat(0);
//     }
   }
   break;
   case  PIRMOTION:{
//     if(generalDevice.getPort()!=port){
//       generalDevice.reset(port);
//       pinMode(generalDevice.pin2(),INPUT);
//     }
//     value = generalDevice.dRead2();
//     sendFloat(value);
   }
   break;
   case  LINEFOLLOWER:{
//     if(generalDevice.getPort()!=port){
//       generalDevice.reset(port);
//         pinMode(generalDevice.pin1(),INPUT);
//         pinMode(generalDevice.pin2(),INPUT);
//     }
//     value = generalDevice.dRead1()*2+generalDevice.dRead2();
//     sendFloat(value);
   }
   break;
   case LIMITSWITCH:{
//     slot = readBuffer(7);
//     if(generalDevice.getPort()!=port||generalDevice.getSlot()!=slot){
//       generalDevice.reset(port,slot);
//     }
//     if(slot==1){
//       pinMode(generalDevice.pin1(),INPUT_PULLUP);
//       value = !generalDevice.dRead1();
//     }else{
//       pinMode(generalDevice.pin2(),INPUT_PULLUP);
//       value = !generalDevice.dRead2();
//     }
//     sendFloat(value);  
   }
   break;
//   case COMPASS:{
//     if(Compass.getPort()!=port){
//       Compass.reset(port);
//       Compass.setpin(Compass.pin1(),Compass.pin2());
//     }
//     double CompassAngle;
//     CompassAngle = Compass.getAngle();
//     sendDouble(CompassAngle);
//   }
//   break;
   case HUMITURE:{
//     uint8_t index = readBuffer(7);
//     if(humiture.getPort()!=port){
//       humiture.reset(port);
//     }
//     uint8_t HumitureData;
//     humiture.update();
//     HumitureData = humiture.getValue(index);
//     sendByte(HumitureData);
   }
   break;


   case FLAMESENSOR:{
//     if(FlameSensor.getPort()!=port){
//       FlameSensor.reset(port);
//       FlameSensor.setpin(FlameSensor.pin2(),FlameSensor.pin1());
//     }
//     int16_t FlameData; 
//     FlameData = FlameSensor.readAnalog();
//     sendShort(FlameData);
   }
   break;
   case GASSENSOR:{
//     if(GasSensor.getPort()!=port){
//       GasSensor.reset(port);
//       GasSensor.setpin(GasSensor.pin2(),GasSensor.pin1());
//     }
//     int16_t GasData; 
//     GasData = GasSensor.readAnalog();
//     sendShort(GasData);
   }
   break;
   case  GYRO:{
//       int axis = readBuffer(7);
//       gyro.update();
//       if(axis == 1){
//         value = gyro.getAngleX();
//         sendFloat(value);
//       }else if(axis == 2){
//         value = gyro.getAngleY();
//         sendFloat(value);
//       }else if(axis == 3){
//         value = gyro.getAngleZ();
//         sendFloat(value);
//       }
   }
   break;
   case  VERSION:{
     sendString(mVersion);
   }
   break;
   case  DIGITAL:{
     pinMode(pin,INPUT);
     sendFloat(digitalRead(pin));
   }
   break;
   case  ANALOG:{
     sendFloat(analogRead(pin)/4);
   }
   break;   

   case  INBUILT_SENSORS:{
    
   int mode = buffer[6];
   switch(mode)
   {
    case LDR:
    {
     sendFloat(analogRead(LDR_PIN)/4);
    }
    break;
    case POT:
    {
     pinMode(POT_PIN,INPUT);
     sendFloat(analogRead(POT_PIN)/4);
    }
    break;
    case LEFT_BUTTON:
    {  
     pinMode(BUTTON_L,INPUT);
     sendFloat(digitalRead(BUTTON_L));
    } 
    break;
    case RIGHT_BUTTON:
    {
      pinMode(BUTTON_R,INPUT);
    sendFloat(digitalRead(BUTTON_R));
   }
   break;
   }
      }
   break;

   case HUMITURE_TEST:{
   // pinMode(HUMITURE_PIN,INPUT);  
   int pin = buffer[6];
   int mode = buffer[7];
   DHT dht(pin, DHTTYPE);
   dht.begin();
    switch(mode)
    {
        case 0:
        {
          sendFloat(dht.readTemperature());
        }
        break;
        case 1:
        {
         sendFloat(dht.readHumidity());          
        }
        break;
    }

   }
   break;
      
   case  PULSEIN:{
     int pw = readShort(7);
     pinMode(pin, INPUT);
     sendShort(pulseIn(pin,FALLING,pw));
   }
   break;

   break;
   case TIMER:{
     sendFloat((float)currentTime);
   }
   break;
  }
}


void runModule(int device){
  //0xff 0x55 0x6 0x0 0x1 0xa 0x9 0x0 0x0 0xa
  int port = readBuffer(6);
  int pin = port;

  switch(device){
   case MOTOR:{
     int speed = readShort(7);
    }
    break;
    case JOYSTICK:{
     int leftSpeed = readShort(6);
     int rightSpeed = readShort(8);
    }
    break;
    case STEPPER:{
     int maxSpeed = readShort(7);
     long distance = readLong(9);
    }
    break;
    case ENCODER:{
      int slot = readBuffer(7);
      int maxSpeed = readShort(8);
      float distance = readFloat(10);
    }
    break;
   case RGBLED:{
     int slot = readBuffer(7);
     int idx = readBuffer(8);
     int r = readBuffer(9);
     int g = readBuffer(10);
     int b = readBuffer(11);
     if(idx>0)
     {
       //led.setColorAt(idx-1,r,g,b); 
     }
     else
     {
       //led.setColor(r,g,b); 
     }
     //led.show();
   }
   break;
   case SERVO:{
   
    Servo myservo;  
       
     int angle = buffer[7];
     int servoPin = buffer[6];

     angle = constrain(angle,0,360);
     myservo.setPeriodHertz(50);    
     myservo.attach(servoPin, 1000, 2000); 
     myservo.write(angle);     

   }
   break;
   case SEVSEG:{
  //   if(seg.getPort()!=port){
       //seg.reset(port);
    // }
     float v = readFloat(7);
     //seg.display(v);
   }
   break;
   case LIGHT_SENSOR:{
     //if(generalDevice.getPort()!=port){
       //generalDevice.reset(port);
     //}
     int v = readBuffer(7);
     //generalDevice.dWrite1(v);
   }
   break;
   case SHUTTER:{
    // if(generalDevice.getPort()!=port){
      // generalDevice.reset(port);
    // }
     int v = readBuffer(7);
     //if(v<2){
     //  generalDevice.dWrite1(v);
     //}else{
     //  generalDevice.dWrite2(v-2);
     //}
   }
   break;
   case DIGITAL:{
     pinMode(pin,OUTPUT);
     int v = readBuffer(7);
     digitalWrite(pin,v);
   }
   break;
   case PWM:{
     pinMode(pin,OUTPUT);
     int v = readBuffer(7);
    // analogWrite(pin,v);
   }
   break;
   case TONE:{

     int pin = readShort(6);
     int hz = readShort(7);
     int ms = readShort(9);
     if(hz>0){
       toneTest(pin,hz,ms);
     }else{
       digitalWrite(pin,LOW); 
     }

   }
   break;

   case  SET_LED:{
     pinMode(YELLOW,OUTPUT);
     pinMode(BLUE,OUTPUT);
     pinMode(GREEN,OUTPUT);
     pinMode(RED,OUTPUT);
     int color = readShort(7);
     int mode = readShort(9);

   if(mode > 0){  
    switch (color) {
  case 17:
    digitalWrite(YELLOW,HIGH);
    
    break;
  case 33:
    digitalWrite(BLUE,HIGH);
    break;
  case 32:
    digitalWrite(GREEN,HIGH);
    break;
  case 16:
    digitalWrite(RED,HIGH);
    break;
  default:  
  digitalWrite(YELLOW,LOW);
  digitalWrite(BLUE,LOW);
  digitalWrite(GREEN,LOW);
  digitalWrite(RED,LOW);
   
}
   }
 else{  
    switch (color) {
  case 17:
    digitalWrite(YELLOW,LOW);  
    break;
  case 33:
    digitalWrite(BLUE,LOW);
    break;
  case 32:
   digitalWrite(GREEN,LOW);
    break;
  case 16:
    digitalWrite(RED,LOW);
    break;
   default:  
  digitalWrite(YELLOW,HIGH); 
  digitalWrite(BLUE,HIGH);
  digitalWrite(GREEN,HIGH);  
  digitalWrite(RED,HIGH);

}
   }
   
    }
   break; 
   
   case RUN_MOTOR:{

   pinMode(MOTOR_A1,OUTPUT);
   pinMode(MOTOR_A2,OUTPUT);
   pinMode(MOTOR_B1,OUTPUT);
   pinMode(MOTOR_B2,OUTPUT);

   int Mtype = buffer[7];
   int Mspeed = buffer[11];
   int Mdirect = buffer[9];
   int channel_A = 0;
   int channel_B = 0;
   
   Mspeed = constrain(Mspeed, 0, 100);
  
 if(Mtype > 0)
 {
  //  ("MOTOR_A...");
    channel_A = pwmChannel(MOTOR_A2);
    ledcSetup(channel_A, freq, resolution);
    
   if(Mdirect>0)
   {
   // ("FORWARD...");
    digitalWrite(MOTOR_A1,HIGH);  
    ledcAttachPin(MOTOR_A2,channel_A);
    ledcWrite(channel_A, 10.24*(100-Mspeed));
    
    }
    else{
   // ("BACKWARD...");  
    digitalWrite(MOTOR_A1,LOW);
    ledcAttachPin(MOTOR_A2,channel_A);     
    ledcWrite(channel_A, 10.24*(Mspeed));
      }
  
  }
 else{
   //  ("MOTOR_B...");
   channel_B = pwmChannel(MOTOR_B2);
    ledcSetup(channel_B, freq, resolution);   
    if(Mdirect>0)
   {
   //  ("FORWARD...");
    digitalWrite(MOTOR_B1,HIGH);  
    ledcAttachPin(MOTOR_B2,channel_B);
    ledcWrite(channel_B, 10.24*(100-Mspeed));
    }
    else{
   //  ("BACKWARD...");
    digitalWrite(MOTOR_B1,LOW);
    ledcAttachPin(MOTOR_B2,channel_B);     
    ledcWrite(channel_B, 10.24*(Mspeed));
      }
  
  }

   }
   break;


   case DISPLAY_TEST:{

   String msg;  
   int  sizes = readShort(6);
   int X_coordinate = buffer[8];
   int Y_coordinate = buffer[9];

   X_coordinate = constrain(X_coordinate,0,128);
   Y_coordinate = constrain(Y_coordinate,0,64);
 // display.clearDisplay();
  display.setTextSize(sizes);
  display.setTextColor(WHITE);
  display.setCursor((X_coordinate),(Y_coordinate));
  for (int i = 10; i <32; i++) {
  display.print(buffer[i]);
  if(buffer[i]=='\n')
  break;
  }  
  display.display();

   }
   break;

   case CLEAR_DISPLAY:{
  
  display.clearDisplay();
   }
   break;
   
    case DRAW_SHAPE:{
     int scale = readShort(6);
     int shape = readShort(8);

     drawShapes( scale , shape);

   }
   break;

    case DRAW_SMILE:{
     int smile = readShort(7);
  switch(smile)
  {
    case 1:
    {
  display.clearDisplay();
  display.drawBitmap(0, 0, SMILE, 128, 64, 1);
  display.display();
      }
     break;
    case 2:
    {
  display.clearDisplay();
  display.drawBitmap(0, 0, SAD, 128, 64, 1);
  display.display();      
      }
      break;
     case 3:
      {
  display.clearDisplay();
  display.drawBitmap(0, 0, ANGRY, 128, 64, 1);
  display.display();      
        }
        break;
     case 4: 
     {
  display.clearDisplay();
  display.drawBitmap(0, 0, COOL, 128, 64, 1);
  display.display();      
      } 
      break;
     case 5:
     {
  display.clearDisplay();
  display.drawBitmap(0, 0, HEARTEYES, 128, 64, 1);
  display.display();      
      }
      break;   
    }   

   }
   break;
   
  
   case SERVO_PIN:{
//     int v = readBuffer(7);
//      Servo sv = servos[searchServoPin(pin)]; 
//     if(v >= 0 && v <= 180)
//     {
//       if(!sv.attached())
//       {
//         sv.attach(pin);
//       }
//       sv.write(v);
//     }

   }
   break;

   case PWM_TEST:{

   int pin = buffer[6];
   int pwm = buffer[7];
   pinMode(pin,OUTPUT);
   
   int Channel = pwmChannel(pin);
  ledcAttachPin(pin,  Channel);
  ledcSetup( Channel, freq, resolution);
  
  pwm = constrain(pwm, 0, 100);

   if( 0 <= pwm || 100 >= pwm )
   {
ledcWrite(pwmChannel(pin), 10.24*pwm);
   }

   }
   break;
   
   case RGB_TEST:{
  


  int pin = buffer[6]; 
  int r = buffer[7]; 
  int g = buffer[8]; 
  int b = buffer[9];

Adafruit_NeoPixel pixels(16, pin , NEO_GRB + NEO_KHZ800);
  pixels.begin();
  pixels.clear();
  r =constrain(r, 0, 255);
  g =constrain(g, 0, 255);
  b =constrain(b, 0, 255);

 pixels.setPixelColor(0, pixels.Color(r, g, b));
 pixels.show();   
 
   }
   break;

   
   
   case TIMER:{
    lastTime = millis()/1000.0; 
   }
   break;
  }
}


void parseData(){
  isStart = false;
  int idx = readBuffer(3);
  command_index = (uint8_t)idx;
  int action = readBuffer(4);
  int device = readBuffer(5);
  switch(action){
    case GET:{
          writeHead();
          writeSerial(idx);
        readSensor(device);
        writeEnd();
     }
     break;
     case RUN:{
       runModule(device);
       callOK();
     }
      break;
      case RESET:{
        //reset
        callOK();
      }
     break;
     case START:{
        //start
        callOK();
      }
     break;
  }
}
void callOK(){
    writeSerial(0xff);
    writeSerial(0x55);
    writeEnd();
}
void sendByte(char c){
  writeSerial(1);
  writeSerial(c);
}
void sendString(String s){
  int l = s.length();
  writeSerial(4);
  writeSerial(l);
  for(int i=0;i<l;i++){
    writeSerial(s.charAt(i));
  }
}
void sendFloat(float value){ 
     writeSerial(0x2);
     val.floatVal = value;
     writeSerial(val.byteVal[0]);
     writeSerial(val.byteVal[1]);
     writeSerial(val.byteVal[2]);
     writeSerial(val.byteVal[3]);
}
void sendShort(double value){
     writeSerial(3);
     valShort.shortVal = value;
     writeSerial(valShort.byteVal[0]);
     writeSerial(valShort.byteVal[1]);
}
void sendDouble(double value){
     writeSerial(2);
     valDouble.doubleVal = value;
     writeSerial(valDouble.byteVal[0]);
     writeSerial(valDouble.byteVal[1]);
     writeSerial(valDouble.byteVal[2]);
     writeSerial(valDouble.byteVal[3]);
}
short readShort(int idx){
  valShort.byteVal[0] = readBuffer(idx);
  valShort.byteVal[1] = readBuffer(idx+1);
  return valShort.shortVal; 
}
float readFloat(int idx){
  val.byteVal[0] = readBuffer(idx);
  val.byteVal[1] = readBuffer(idx+1);
  val.byteVal[2] = readBuffer(idx+2);
  val.byteVal[3] = readBuffer(idx+3);
  return val.floatVal;
}
long readLong(int idx){
  val.byteVal[0] = readBuffer(idx);
  val.byteVal[1] = readBuffer(idx+1);
  val.byteVal[2] = readBuffer(idx+2);
  val.byteVal[3] = readBuffer(idx+3);
  return val.longVal;
}



void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
    display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
    pinMode(SERVO_PIN,OUTPUT);
  display.clearDisplay();
  display.drawBitmap(0, 0, LOGO, 128, 64, 1);
  display.display();
//  pixels.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)
}

void loop() {
  // put your main code here, to run repeatedly:
    currentTime = millis()/1000.0-lastTime;
readSerial();
if(isAvailable){
    unsigned char c = serialRead&0xff;
    if(c==0x55&&isStart==false){
     if(prevc==0xff){
      indexx=1;
      isStart = true;
     }
    }else{
      prevc = c;
      if(isStart){
        if(indexx==2){
         dataLen = c; 
        }else if(indexx>2){
          dataLen--;
        }
        writeBuffer(indexx,c);
      }
    }
     indexx++;
     if(indexx>60){
      indexx=0; 
      isStart=false;
     }
     if(isStart&&dataLen==0&&indexx>3){ 
        isStart = false;
        parseData(); 
        indexx=0;
     }
  }
////////////////////////
//tone(0, 1000, 500);
/////////////////////  
}


void debug(int val)
{
char buf[10];
sprintf(buf,"val:%d",val);
    display.clearDisplay();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0,0);
   for (int i = 0; i <10; i++) {
    display.print(buf[i]);
  if(buffer[i]=='\0')
  break;
  }  
  display.display();

}

int  pwmChannel(int pin)
{
  int ledChannel = 0;
  
  switch(pin)
  {
    case 16:
    ledChannel = 0;
    break;
    case 17:
    ledChannel = 1;
    break;
    case 25:
    ledChannel = 2;
    break;
    case 32:
    ledChannel = 3;
    break;
    case 33:
    ledChannel = 4;
    break;
    case 18:
    ledChannel = 5;
    break;
    case 21:
    ledChannel = 6;
    break; 
    case 22:
    ledChannel = 7;
    break; 
    case 26:
    ledChannel = 8;
    break;    
    case 27:
    ledChannel = 9;
    break;
    case 1:
    ledChannel = 10;
    break;
    case 2:
    ledChannel = 11;
    break;
    case 12:
    ledChannel = 12;
    break;
    case 13:
    ledChannel = 13;
    break;
    case 14:
    ledChannel = 14;
    break;
    default:
    ledChannel = 15;
    break;                
    }
    return ledChannel;
  }

  void drawShapes(int scale ,int shape)
  {
 //-----------Small Shapes-----------
 
    if((scale == 1) && (shape == 1))
    {
        display.clearDisplay();
        display.drawCircle(64, 32, 10, WHITE);
        display.display();
      }

    else if((scale == 1) && (shape == 2))
     {
        display.clearDisplay();
        display.drawRect(54, 22,20, 20, WHITE);
        display.display();      
      }
    if((scale == 1) && (shape == 3))
    {
        display.clearDisplay();
        display.drawRect(44,22,40,20, WHITE);
        display.display();
      }

    else if((scale == 1) && (shape == 4))
     {
        display.clearDisplay();
        display.drawTriangle(64, 22, 54, 42, 74, 42, WHITE);
        display.display();      
      }     
   if((scale == 1) && (shape == 5))
    {
        display.clearDisplay();
        display.fillRect(54, 22,20, 20, WHITE);
        display.display();
      }

    else if((scale == 1) && (shape == 6))
     {
        display.clearDisplay();
        display.fillCircle(64, 32, 10, WHITE);
        display.display();      
      }
    if((scale == 1) && (shape == 7))
    {
        display.clearDisplay();
  display.drawBitmap(0, 0, HEART, 128, 64, 1);
        display.display();
      }

    else if((scale == 1) && (shape == 8))
     {
        display.clearDisplay();
        display.fillTriangle(64, 22, 54, 42, 74, 42, WHITE);
        display.display();      
      }  
    else if((scale == 1) && (shape == 9))
     {
        display.clearDisplay();
        display.drawRoundRect(54, 22, 20, 20, 4, WHITE);
        display.display();      
      }           

//---------Medium Shapes---------------


    if((scale == 2) && (shape == 1))
    {
        display.clearDisplay();
        display.drawCircle(64, 32, 20, WHITE);
        display.display();
      }

    else if((scale == 2) && (shape == 2))
     {
        display.clearDisplay();
        display.drawRect(44, 12,40, 40, WHITE);
        display.display();      
      }
    if((scale == 2) && (shape == 3))
    {
        display.clearDisplay();
        display.drawRect(24,12,80,40, WHITE);
        display.display();
      }

    else if((scale == 2) && (shape == 4))
     {
        display.clearDisplay();
        display.drawTriangle(64, 12, 44, 52, 84, 52, WHITE);
        display.display();      
      }     
   if((scale == 2) && (shape == 5))
    {
        display.clearDisplay();
        display.fillRect(44, 12,40, 40, WHITE);
        display.display();
      }

    else if((scale == 2) && (shape == 6))
     {
        display.clearDisplay();
        display.fillCircle(64, 32, 20, WHITE);
        display.display();      
      }
    if((scale == 2) && (shape == 7))
    {
        display.clearDisplay();
  display.drawBitmap(0, 0, HEART, 128, 64, 1);
        display.display();
      }

    else if((scale == 2) && (shape == 8))
     {
        display.clearDisplay();
        display.fillTriangle(64, 12, 44, 52, 84, 52, WHITE);
        display.display();      
      }  
    else if((scale == 2) && (shape == 9))
     {
        display.clearDisplay();
        display.drawRoundRect(44, 12, 40, 40, 8, WHITE);
        display.display();      
      } 

//-------------Large Shapes---------------//
    if((scale == 3) && (shape == 1))
    {
        display.clearDisplay();
        display.drawCircle(64, 32, 31, WHITE);
        display.display();
      }

    else if((scale == 3) && (shape == 2))
     {
        display.clearDisplay();
        display.drawRect(34, 2,60, 60, WHITE);
        display.display();      
      }
    if((scale == 3) && (shape == 3))
    {
        display.clearDisplay();
        display.drawRect(2,2,126,60, WHITE);
        display.display();
      }

    else if((scale == 3) && (shape == 4))
     {
        display.clearDisplay();
        display.drawTriangle(64, 2, 34, 62, 94, 62, WHITE);
        display.display();      
      }     
   if((scale == 3) && (shape == 5))
    {
        display.clearDisplay();
        display.fillRect(39, 7,50, 50, WHITE);
        display.display();
      }

    else if((scale == 3) && (shape == 6))
     {
        display.clearDisplay();
        display.fillCircle(64, 32, 31, WHITE);
        display.display();      
      }
    if((scale == 3) && (shape == 7))
    {
        display.clearDisplay();
  display.drawBitmap(0, 0, HEART, 128, 64, 1);
        display.display();
      }

    else if((scale == 3) && (shape == 8))
     {
        display.clearDisplay();
        display.fillTriangle(64, 2, 34, 62, 94, 62, WHITE);
        display.display();      
      }  
    else if((scale == 3) && (shape == 9))
     {
        display.clearDisplay();
        display.drawRoundRect(34, 2, 60, 60, 8, WHITE);
        display.display();      
      }        
          
  } 


  
void toneTest(int pin,uint16_t frequency, uint32_t duration)
{
  int period = 1000000L / frequency;
  int pulse = period / 2;
  pinMode(pin, OUTPUT);
  for (long i = 0; i < duration * 1000L; i += period) 
  {
    digitalWrite(pin, HIGH);
    delayMicroseconds(pulse);
    digitalWrite(pin, LOW);
    delayMicroseconds(pulse);
  }
}
